image: docker
services:
  - docker:dind

stages:
  - build
  - deploy
  - production
  - cleanup

variables:
  CONTAINER_TEST_IMAGE: $CI_REGISTRY_IMAGE:latest
  DOCKER_REGISTRY: 331909484456.dkr.ecr.eu-west-1.amazonaws.com
  DOCKER_HOST: tcp://docker:2375
  APP_NAME: counter-service
  AWS_ACCESS_KEY_ID: $AWS_ACCESS_KEY_ID 
  AWS_DEFAULT_REGION: $AWS_DEFAULT_REGION



build:
  stage: build
  image: 
    name: amazon/aws-cli
    entrypoint: [""]
  services:
    - docker:dind
  before_script:
    - amazon-linux-extras install docker
    - aws --version
    - docker --version
  script:
    - docker build -t $DOCKER_REGISTRY/$APP_NAME .
    - docker login -u AWS -p $(aws ecr get-login-password --region eu-west-1) $DOCKER_REGISTRY
    - docker push $DOCKER_REGISTRY/$APP_NAME

deploy:
  stage: deploy
  image:
     name: bitnami/kubectl:latest
     entrypoint: [""]
  script:
   - kubectl config get-contexts
   - kubectl config use-context checkpointex/counter-service:counter-cluster-image
   - kubectl get pods
   - kubectl delete pods $APP_NAME
   - kubectl run $APP_NAME --image $DOCKER_REGISTRY/$APP_NAME
  